import greenfoot.*;
public class Canon extends Actor
{
    public int player;
    public Canon(int player)
    {
        this.player=player;
        if (player == 2)
        {
            getImage().mirrorHorizontally();
        }
        getImage().scale(50, 30);
    }
    public void act()
    {
        if (getObjectsInRange(50, Personnage.class).isEmpty()==false)
        {
            tourner();
            tirer();
        }
    }
    /**
     * tourne le canon de façon à pointer vers la souris
     */
    public void tourner()
    {
        if(Greenfoot.mouseMoved(null))
        {
            MouseInfo mouse=Greenfoot.getMouseInfo();
            int rX,rY;
            if (player == 1)
            {
                rX=mouse.getX()-getX();
                rY=mouse.getY()-getY();
                int angle=(int)(Math.atan2(rY,rX)*180.0/Math.PI);
                if(angle<=0 && angle>-90)
                {
                    setRotation(angle);
                }
            }
            else
            {
                rX=getX()-mouse.getX();
                rY=getY()-mouse.getY(); 
                int angle=(int)(Math.atan2(rY,rX)*180.0/Math.PI);
                if(angle>=0 && angle<90)
                {
                    setRotation(angle);
                }
            }
        }
    }
    /**
     * tire une munition selon l'angle du canon/ change de tour / ajoute un coeur aléatoirement sur la map
     */
    public void tirer()
    {
        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo mouse=Greenfoot.getMouseInfo();
            int rX, rY, w, posX, posY;
            double r, angle;
            int vitesse = 120;
            if (player == 1)
            {
                rX=mouse.getX()-getX();
                rY=mouse.getY()-getY();
                r=Math.sqrt(Math.pow(rX,2)+Math.pow(rY,2));
                angle=Math.atan2(rY,rX);
                if(angle<=0*Math.PI/180 && angle>-90*Math.PI/180)
                {
                    w=(int) (0.5*getImage().getWidth());
                    posX=(int) (getX()+w*Math.cos(angle));
                    posY=(int) (getY()+w*Math.sin(angle));
                    Munition munition=new Munition(1);
                    munition.setVeloc(vitesse*rX/r,vitesse*rY/r);
                    getWorld().addObject(munition,posX,posY);
                    Eau eau = (Eau) getWorld();
                    eau.personnage1.tour();
                    eau.personnage2.tour();
                    if(Greenfoot.getRandomNumber(100)<=25)
                    {
                        getWorld().addObject(new Coeur(), Greenfoot.getRandomNumber(800)+300,Greenfoot.getRandomNumber(700)+100);
                    }
                }
            }
            if (player == 2)
            {
                rX=getX()-mouse.getX();
                rY=getY()-mouse.getY();
                r=-Math.sqrt(Math.pow(rX,2)+Math.pow(rY,2));
                angle=Math.atan2(rY,rX);
                if(angle>=0*Math.PI/180 && angle<90*Math.PI/180)
                {
                    w=(int) (0.5*getImage().getWidth());
                    posX=(int) (getX()-w*Math.cos(angle));
                    posY=(int) (getY()-w*Math.sin(angle));
                    Munition munition=new Munition(2);
                    munition.setVeloc(vitesse*rX/r,vitesse*rY/r);
                    getWorld().addObject(munition,posX,posY);
                    Eau eau = (Eau) getWorld();
                    eau.personnage1.tour();
                    eau.personnage2.tour();
                    if(Greenfoot.getRandomNumber(100)<=25)
                    {
                        getWorld().addObject(new Coeur(), Greenfoot.getRandomNumber(800)+300,Greenfoot.getRandomNumber(700)+100);
                    }
                }
            }
        }
    }
}
